package com.example.redisCache.repository;

import com.example.redisCache.entity.Product;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class ProductDao {

    public static final String HASH_KEY = "Product";
    @Autowired
    private RedisTemplate template;

    public Product save(Product product){
        System.out.println(">> ProductDao save start");
        template.opsForHash().put(HASH_KEY,product.getId(),product);
        System.out.println(">> ProductDao save end");
        return product;
    }

    public List<Product> findAll(){
        System.out.println(">> ProductDao findAll start");
        System.out.println(">> ProductDao findAll end");
        return template.opsForHash().values(HASH_KEY);

    }

    public Product findProductById(int id){
        System.out.println(">> ProductDao findProductById start");
        System.out.println(">> ProductDao findProductById end");
        return (Product) template.opsForHash().get(HASH_KEY,id);
    }

    public Product updateProduct(Product product){
        System.out.println(">> ProductDao updateProduct start");
       template.opsForHash().put(HASH_KEY,product.getId(),product);
        System.out.println(">> ProductDao updateProduct end");
       return product;
    }

    public String deleteProductById(int id){
        template.opsForHash().delete(HASH_KEY,id);
        return "product deleted!!";
    }
}
